"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
const _excludeSubDir = require("../excludeSubDir");
describe('excludeSubDir', ()=>{
    it('excludeSubDir', ()=>{
        const data = [
            '/a/b/c/d',
            '/a/aa/vv',
            '/a/b/c',
            '/a/aa'
        ];
        expect((0, _excludeSubDir.excludeSubDir)(data)).toEqual([
            '/a/b/c',
            '/a/aa'
        ].sort((a, z)=>a > z ? 1 : -1));
    });
    it('include all dir if no overlap', ()=>{
        const data = [
            '/a/bb/c/d',
            '/a/aaa/vv',
            '/a/b/c',
            '/a/aa'
        ];
        expect((0, _excludeSubDir.excludeSubDir)(data)).toEqual([
            '/a/bb/c/d',
            '/a/aaa/vv',
            '/a/b/c',
            '/a/aa'
        ].sort((a, z)=>a > z ? 1 : -1));
    });
});
