"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.excludeSubDir = void 0;
const path_1 = __importDefault(require("path"));
const isSub = (parent, dir) => {
    const relative = path_1.default.relative(parent, dir);
    return !!relative && !relative.startsWith('..') && !path_1.default.isAbsolute(relative);
};
const excludeSubDir = (dirs) => {
    const sorted = [...dirs]
        .sort((a, z) => a.length - z.length);
    const result = [];
    for (let i = sorted.length - 1; i >= 0; i -= 1) {
        if (sorted.slice(0, i).every(xs => !isSub(xs, sorted[i]))) {
            result.push(sorted[i]);
        }
    }
    return result.sort((a, z) => a > z ? 1 : -1);
};
exports.excludeSubDir = excludeSubDir;
