"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.calcTransformerOptions = void 0;
const calcTransformerOptions = async (config, options) => {
    const baseOptions = {
        customTransformOptions: options.customTransformOptions,
        dev: options.dev,
        hot: options.hot,
        inlineRequires: false,
        inlinePlatform: true,
        minify: options.minify,
        platform: options.platform,
        runtimeBytecodeVersion: options.runtimeBytecodeVersion,
        unstable_transformProfile: options.unstable_transformProfile,
    };
    if (options.type === 'script') {
        return {
            ...baseOptions,
            type: 'script',
        };
    }
    // FIXME: 可以带参数, 但是实际上没有参数, 也不需要
    // @ts-ignore
    const { transform } = await config.transformer.getTransformOptions();
    return {
        ...baseOptions,
        inlineRequires: (transform === null || transform === void 0 ? void 0 : transform.inlineRequires) || false,
        experimentalImportSupport: (transform === null || transform === void 0 ? void 0 : transform.experimentalImportSupport) || false,
        unstable_disableES6Transforms: (transform === null || transform === void 0 ? void 0 : transform.unstable_disableES6Transforms) || false,
        nonInlinedRequires: (transform === null || transform === void 0 ? void 0 : transform.nonInlinedRequires) || ['React', 'react', 'react-native'],
        type: 'module',
    };
};
exports.calcTransformerOptions = calcTransformerOptions;
