"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-ignore
const baseJSBundle_1 = __importDefault(require("metro/src/DeltaBundler/Serializers/baseJSBundle"));
// @ts-ignore
const sourceMapString_1 = __importDefault(require("metro/src/DeltaBundler/Serializers/sourceMapString"));
const path_1 = __importDefault(require("path"));
const bunldeToString_1 = require("./bunldeToString");
const getSortedModules_1 = require("./getSortedModules");
const fs_extra_1 = __importDefault(require("fs-extra"));
const md5_1 = __importDefault(require("../lib/md5"));
const saveOutput = async (outputOptions) => {
    const { entryAbsPath, outputDir, bundleName, id, dependencyGraph, graph, config, serializerOptions, prepend, platform, } = outputOptions;
    const outputAbsPath = path_1.default.join(outputDir, bundleName);
    const bundleOptions = {
        asyncRequireModulePath: dependencyGraph.resolveDependency(`${config.projectRoot}/.`, config.transformer.asyncRequireModulePath),
        processModuleFilter: config.serializer.processModuleFilter,
        createModuleId: config.serializer.createModuleIdFactory(),
        getRunModuleStatement: config.serializer.getRunModuleStatement,
        dev: false,
        projectRoot: config.projectRoot,
        modulesOnly: serializerOptions.modulesOnly,
        runBeforeMainModule: config.serializer.getModulesRunBeforeMainModule(path_1.default.relative(config.projectRoot, entryAbsPath)),
        runModule: serializerOptions.runModule,
        sourceMapUrl: serializerOptions.sourceMapUrl || `${bundleName}.map`,
        sourceUrl: serializerOptions.sourceUrl,
        inlineSourceMap: serializerOptions.inlineSourceMap,
        serverRoot: config.projectRoot,
    };
    const bundleCode = (0, bunldeToString_1.bundleToString)((0, baseJSBundle_1.default)(entryAbsPath, prepend, graph, bundleOptions)).code;
    const bundleMap = (0, sourceMapString_1.default)([...prepend, ...(0, getSortedModules_1.getSortedModules)(graph, config.serializer.createModuleIdFactory())], {
        excludeSource: serializerOptions.excludeSource,
        processModuleFilter: config.serializer.processModuleFilter,
    });
    await fs_extra_1.default.ensureDir(path_1.default.dirname(outputAbsPath));
    await Promise.all([
        fs_extra_1.default.writeFile(outputAbsPath, bundleCode, { encoding: 'utf8' }),
        fs_extra_1.default.writeFile(`${outputAbsPath}.map`, bundleMap),
    ]);
    return {
        entryAbsPath,
        outputDir,
        id,
        bundleAbsPath: outputAbsPath,
        bundleMd5: await (0, md5_1.default)(outputAbsPath),
        platform,
    };
};
exports.default = saveOutput;
