import { ConfigT } from "metro-config";
export interface ExtMetroConfig extends ConfigT {
    mode: 'development' | 'production';
    babelPlugins?: any[];
    hyextTransformerConfig?: {
        [key: string]: any;
    };
    assetsDir: string;
    imageBaseURL: string;
    filterModules?: Set<string>;
    filterModulesVersion?: Set<string>;
    SDKAlias?: {
        [aliasName: string]: string[];
    };
    extraModulesRunFirst?: string[];
    extraPolyfills?: string[];
    blockRegexp?: Array<RegExp>;
}
export type Platform = 'ios' | 'android';
export type BundleConfigItem = {
    entryAbsPath: string;
    outputDir: string;
    id: string;
};
export interface CompileExtInput {
    mode: 'development' | 'production';
    projectRoot: string;
    bundleConfigs: BundleConfigItem[];
    extUuid: string;
    projectConfig: {
        cacheVersion?: number | string;
    };
    extMetroConfig: Partial<ExtMetroConfig>;
}
export type CompileExtOutput = Array<BundleConfigItem & {
    bundleAbsPath: string;
    bundleMd5: string;
    platform: Platform;
}>;
export interface ServerInput extends Omit<CompileExtInput, 'bundleConfigs'> {
    onRequest?: (queryUrl: string) => void | Promise<void>;
    interactive?: boolean;
    onReady?: () => void | Promise<void>;
    onError?: () => void | Promise<void>;
    customLogReporterPath?: any;
    host?: string;
    port?: number;
    https?: string;
    cert?: string;
    key?: string;
}
