/// <reference types="node" />
import { ExtMetroConfig } from './configTypes';
interface BaseOptions {
    projectRoot: string;
    extMetroConfig: Partial<ExtMetroConfig>;
    projectConfig?: {
        cacheVersion?: number | string;
        [key: string]: any;
    };
    isOffline?: boolean;
}
interface DevOptions extends BaseOptions {
    mode: 'development';
    port?: number;
}
interface ProdOptions extends BaseOptions {
    mode: 'production';
}
export declare const skipModulePlaceHolder: {
    dependencies: never[];
    output: never[];
    getSource: () => Buffer;
};
export declare const getExtraNodeModules: (projectRoot: string, fromPkgName?: string) => {};
export declare const safeReadSync: (filePath?: string) => string;
export declare const getCacheVersion: (rawVersion?: string | number, dep?: string[]) => string;
export declare function getExtMetroConfig(options: DevOptions | ProdOptions): ExtMetroConfig;
export {};
